Index: ckeditortrac/__init__.py
===================================================================
--- ckeditortrac/__init__.py	(revision 2098)
+++ ckeditortrac/__init__.py	(working copy)
@@ -37,7 +37,8 @@
         add_stylesheet(req, 'ckeditortrac/wysiwyg.css')
         add_script(req, 'ckeditortrac/ckeditortrac_load.js')
         add_script(req, 'ckeditortrac/ckeditor/ckeditor.js')
-        add_script(req, 'tracwysiwyg/ckeditor/adapters/jquery.js')
+#       add_script(req, 'tracwysiwyg/ckeditor/adapters/jquery.js')
+        add_script(req, 'ckeditortrac/ckeditor/adapters/jquery.js')
         
 
         return (template, data, content_type)
Index: setup.py
===================================================================
--- setup.py	(revision 2098)
+++ setup.py	(working copy)
@@ -11,8 +11,232 @@
     author_email = 'edanm@btlms.com',
     packages = find_packages(exclude=['*.tests*']),
     package_data = {
-        'ckeditortrac' : [ 'htdocs/*.js', 'htdocs/*.css', 'htdocs/*.png'],
-
+        'ckeditortrac' : [ 
+                'htdocs/*.*',
+                'htdocs/ckeditor/*.*',
+                'htdocs/ckeditor/plugins/*.*',
+                'htdocs/ckeditor/plugins/find/*.*',
+                'htdocs/ckeditor/plugins/find/dialogs/*.*',
+                'htdocs/ckeditor/plugins/pastetext/*.*',
+                'htdocs/ckeditor/plugins/pastetext/dialogs/*.*',
+                'htdocs/ckeditor/plugins/pagebreak/*.*',
+                'htdocs/ckeditor/plugins/pagebreak/images/*.*',
+                'htdocs/ckeditor/plugins/placeholder/*.*',
+                'htdocs/ckeditor/plugins/placeholder/lang/*.*',
+                'htdocs/ckeditor/plugins/placeholder/dialogs/*.*',
+                'htdocs/ckeditor/plugins/div/*.*',
+                'htdocs/ckeditor/plugins/div/dialogs/*.*',
+                'htdocs/ckeditor/plugins/image/*.*',
+                'htdocs/ckeditor/plugins/image/dialogs/*.*',
+                'htdocs/ckeditor/plugins/styles/*.*',
+                'htdocs/ckeditor/plugins/styles/styles/*.*',
+                'htdocs/ckeditor/plugins/scayt/*.*',
+                'htdocs/ckeditor/plugins/scayt/dialogs/*.*',
+                'htdocs/ckeditor/plugins/iframedialog/*.*',
+                'htdocs/ckeditor/plugins/a11yhelp/*.*',
+                'htdocs/ckeditor/plugins/a11yhelp/lang/*.*',
+                'htdocs/ckeditor/plugins/a11yhelp/dialogs/*.*',
+                'htdocs/ckeditor/plugins/forms/*.*',
+                'htdocs/ckeditor/plugins/forms/dialogs/*.*',
+                'htdocs/ckeditor/plugins/forms/images/*.*',
+                'htdocs/ckeditor/plugins/table/*.*',
+                'htdocs/ckeditor/plugins/table/dialogs/*.*',
+                'htdocs/ckeditor/plugins/wsc/*.*',
+                'htdocs/ckeditor/plugins/wsc/dialogs/*.*',
+                'htdocs/ckeditor/plugins/pastefromword/*.*',
+                'htdocs/ckeditor/plugins/pastefromword/filter/*.*',
+                'htdocs/ckeditor/plugins/liststyle/*.*',
+                'htdocs/ckeditor/plugins/liststyle/dialogs/*.*',
+                'htdocs/ckeditor/plugins/link/*.*',
+                'htdocs/ckeditor/plugins/link/dialogs/*.*',
+                'htdocs/ckeditor/plugins/link/images/*.*',
+                'htdocs/ckeditor/plugins/flash/*.*',
+                'htdocs/ckeditor/plugins/flash/dialogs/*.*',
+                'htdocs/ckeditor/plugins/flash/images/*.*',
+                'htdocs/ckeditor/plugins/colordialog/*.*',
+                'htdocs/ckeditor/plugins/colordialog/dialogs/*.*',
+                'htdocs/ckeditor/plugins/templates/*.*',
+                'htdocs/ckeditor/plugins/templates/dialogs/*.*',
+                'htdocs/ckeditor/plugins/templates/templates/*.*',
+                'htdocs/ckeditor/plugins/templates/templates/images/*.*',
+                'htdocs/ckeditor/plugins/dialog/*.*',
+                'htdocs/ckeditor/plugins/clipboard/*.*',
+                'htdocs/ckeditor/plugins/clipboard/dialogs/*.*',
+                'htdocs/ckeditor/plugins/smiley/*.*',
+                'htdocs/ckeditor/plugins/smiley/dialogs/*.*',
+                'htdocs/ckeditor/plugins/smiley/images/*.*',
+                'htdocs/ckeditor/plugins/iframe/*.*',
+                'htdocs/ckeditor/plugins/iframe/dialogs/*.*',
+                'htdocs/ckeditor/plugins/iframe/images/*.*',
+                'htdocs/ckeditor/plugins/adobeair/*.*',
+                'htdocs/ckeditor/plugins/autogrow/*.*',
+                'htdocs/ckeditor/plugins/tabletools/*.*',
+                'htdocs/ckeditor/plugins/tabletools/dialogs/*.*',
+                'htdocs/ckeditor/plugins/tableresize/*.*',
+                'htdocs/ckeditor/plugins/about/*.*',
+                'htdocs/ckeditor/plugins/about/dialogs/*.*',
+                'htdocs/ckeditor/plugins/uicolor/*.*',
+                'htdocs/ckeditor/plugins/uicolor/lang/*.*',
+                'htdocs/ckeditor/plugins/uicolor/dialogs/*.*',
+                'htdocs/ckeditor/plugins/uicolor/yui/*.*',
+                'htdocs/ckeditor/plugins/uicolor/yui/assets/*.*',
+                'htdocs/ckeditor/plugins/showblocks/*.*',
+                'htdocs/ckeditor/plugins/showblocks/images/*.*',
+                'htdocs/ckeditor/plugins/specialchar/*.*',
+                'htdocs/ckeditor/plugins/specialchar/lang/*.*',
+                'htdocs/ckeditor/plugins/specialchar/dialogs/*.*',
+                'htdocs/ckeditor/lang/*.*',
+                'htdocs/ckeditor/themes/*.*',
+                'htdocs/ckeditor/themes/default/*.*',
+                'htdocs/ckeditor/skins/*.*',
+                'htdocs/ckeditor/skins/office2003/*.*',
+                'htdocs/ckeditor/skins/office2003/images/*.*',
+                'htdocs/ckeditor/skins/v2/*.*',
+                'htdocs/ckeditor/skins/v2/images/*.*',
+                'htdocs/ckeditor/skins/kama/*.*',
+                'htdocs/ckeditor/skins/kama/images/*.*',
+                'htdocs/ckeditor/_source/*.*',
+                'htdocs/ckeditor/_source/lang/*.*',
+                'htdocs/ckeditor/_source/plugins/*.*',
+                'htdocs/ckeditor/_source/plugins/pagebreak/*.*',
+                'htdocs/ckeditor/_source/plugins/pagebreak/images/*.*',
+                'htdocs/ckeditor/_source/plugins/image/*.*',
+                'htdocs/ckeditor/_source/plugins/image/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/placeholder/*.*',
+                'htdocs/ckeditor/_source/plugins/placeholder/lang/*.*',
+                'htdocs/ckeditor/_source/plugins/placeholder/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/styles/*.*',
+                'htdocs/ckeditor/_source/plugins/styles/styles/*.*',
+                'htdocs/ckeditor/_source/plugins/listblock/*.*',
+                'htdocs/ckeditor/_source/plugins/htmldataprocessor/*.*',
+                'htdocs/ckeditor/_source/plugins/colordialog/*.*',
+                'htdocs/ckeditor/_source/plugins/colordialog/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/clipboard/*.*',
+                'htdocs/ckeditor/_source/plugins/clipboard/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/panel/*.*',
+                'htdocs/ckeditor/_source/plugins/menubutton/*.*',
+                'htdocs/ckeditor/_source/plugins/htmlwriter/*.*',
+                'htdocs/ckeditor/_source/plugins/menu/*.*',
+                'htdocs/ckeditor/_source/plugins/undo/*.*',
+                'htdocs/ckeditor/_source/plugins/removeformat/*.*',
+                'htdocs/ckeditor/_source/plugins/autogrow/*.*',
+                'htdocs/ckeditor/_source/plugins/bidi/*.*',
+                'htdocs/ckeditor/_source/plugins/colorbutton/*.*',
+                'htdocs/ckeditor/_source/plugins/fakeobjects/*.*',
+                'htdocs/ckeditor/_source/plugins/indent/*.*',
+                'htdocs/ckeditor/_source/plugins/dialogadvtab/*.*',
+                'htdocs/ckeditor/_source/plugins/horizontalrule/*.*',
+                'htdocs/ckeditor/_source/plugins/scayt/*.*',
+                'htdocs/ckeditor/_source/plugins/scayt/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/entities/*.*',
+                'htdocs/ckeditor/_source/plugins/newpage/*.*',
+                'htdocs/ckeditor/_source/plugins/elementspath/*.*',
+                'htdocs/ckeditor/_source/plugins/link/*.*',
+                'htdocs/ckeditor/_source/plugins/link/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/link/images/*.*',
+                'htdocs/ckeditor/_source/plugins/justify/*.*',
+                'htdocs/ckeditor/_source/plugins/dialogui/*.*',
+                'htdocs/ckeditor/_source/plugins/flash/*.*',
+                'htdocs/ckeditor/_source/plugins/flash/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/flash/images/*.*',
+                'htdocs/ckeditor/_source/plugins/dialog/*.*',
+                'htdocs/ckeditor/_source/plugins/iframe/*.*',
+                'htdocs/ckeditor/_source/plugins/iframe/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/iframe/images/*.*',
+                'htdocs/ckeditor/_source/plugins/stylescombo/*.*',
+                'htdocs/ckeditor/_source/plugins/adobeair/*.*',
+                'htdocs/ckeditor/_source/plugins/about/*.*',
+                'htdocs/ckeditor/_source/plugins/about/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/button/*.*',
+                'htdocs/ckeditor/_source/plugins/pastetext/*.*',
+                'htdocs/ckeditor/_source/plugins/pastetext/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/floatpanel/*.*',
+                'htdocs/ckeditor/_source/plugins/basicstyles/*.*',
+                'htdocs/ckeditor/_source/plugins/sourcearea/*.*',
+                'htdocs/ckeditor/_source/plugins/domiterator/*.*',
+                'htdocs/ckeditor/_source/plugins/panelbutton/*.*',
+                'htdocs/ckeditor/_source/plugins/liststyle/*.*',
+                'htdocs/ckeditor/_source/plugins/liststyle/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/editingblock/*.*',
+                'htdocs/ckeditor/_source/plugins/save/*.*',
+                'htdocs/ckeditor/_source/plugins/keystrokes/*.*',
+                'htdocs/ckeditor/_source/plugins/tab/*.*',
+                'htdocs/ckeditor/_source/plugins/blockquote/*.*',
+                'htdocs/ckeditor/_source/plugins/tableresize/*.*',
+                'htdocs/ckeditor/_source/plugins/wysiwygarea/*.*',
+                'htdocs/ckeditor/_source/plugins/list/*.*',
+                'htdocs/ckeditor/_source/plugins/uicolor/*.*',
+                'htdocs/ckeditor/_source/plugins/uicolor/lang/*.*',
+                'htdocs/ckeditor/_source/plugins/uicolor/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/uicolor/yui/*.*',
+                'htdocs/ckeditor/_source/plugins/uicolor/yui/assets/*.*',
+                'htdocs/ckeditor/_source/plugins/find/*.*',
+                'htdocs/ckeditor/_source/plugins/find/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/preview/*.*',
+                'htdocs/ckeditor/_source/plugins/div/*.*',
+                'htdocs/ckeditor/_source/plugins/div/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/filebrowser/*.*',
+                'htdocs/ckeditor/_source/plugins/iframedialog/*.*',
+                'htdocs/ckeditor/_source/plugins/maximize/*.*',
+                'htdocs/ckeditor/_source/plugins/a11yhelp/*.*',
+                'htdocs/ckeditor/_source/plugins/a11yhelp/lang/*.*',
+                'htdocs/ckeditor/_source/plugins/a11yhelp/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/selection/*.*',
+                'htdocs/ckeditor/_source/plugins/forms/*.*',
+                'htdocs/ckeditor/_source/plugins/forms/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/forms/images/*.*',
+                'htdocs/ckeditor/_source/plugins/enterkey/*.*',
+                'htdocs/ckeditor/_source/plugins/table/*.*',
+                'htdocs/ckeditor/_source/plugins/table/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/format/*.*',
+                'htdocs/ckeditor/_source/plugins/print/*.*',
+                'htdocs/ckeditor/_source/plugins/pastefromword/*.*',
+                'htdocs/ckeditor/_source/plugins/pastefromword/filter/*.*',
+                'htdocs/ckeditor/_source/plugins/wsc/*.*',
+                'htdocs/ckeditor/_source/plugins/wsc/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/templates/*.*',
+                'htdocs/ckeditor/_source/plugins/templates/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/templates/templates/*.*',
+                'htdocs/ckeditor/_source/plugins/templates/templates/images/*.*',
+                'htdocs/ckeditor/_source/plugins/showborders/*.*',
+                'htdocs/ckeditor/_source/plugins/resize/*.*',
+                'htdocs/ckeditor/_source/plugins/smiley/*.*',
+                'htdocs/ckeditor/_source/plugins/smiley/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/smiley/images/*.*',
+                'htdocs/ckeditor/_source/plugins/toolbar/*.*',
+                'htdocs/ckeditor/_source/plugins/popup/*.*',
+                'htdocs/ckeditor/_source/plugins/richcombo/*.*',
+                'htdocs/ckeditor/_source/plugins/font/*.*',
+                'htdocs/ckeditor/_source/plugins/tabletools/*.*',
+                'htdocs/ckeditor/_source/plugins/tabletools/dialogs/*.*',
+                'htdocs/ckeditor/_source/plugins/contextmenu/*.*',
+                'htdocs/ckeditor/_source/plugins/showblocks/*.*',
+                'htdocs/ckeditor/_source/plugins/showblocks/images/*.*',
+                'htdocs/ckeditor/_source/plugins/specialchar/*.*',
+                'htdocs/ckeditor/_source/plugins/specialchar/lang/*.*',
+                'htdocs/ckeditor/_source/plugins/specialchar/dialogs/*.*',
+                'htdocs/ckeditor/_source/adapters/*.*',
+                'htdocs/ckeditor/_source/themes/*.*',
+                'htdocs/ckeditor/_source/themes/default/*.*',
+                'htdocs/ckeditor/_source/skins/*.*',
+                'htdocs/ckeditor/_source/skins/office2003/*.*',
+                'htdocs/ckeditor/_source/skins/office2003/images/*.*',
+                'htdocs/ckeditor/_source/skins/v2/*.*',
+                'htdocs/ckeditor/_source/skins/v2/images/*.*',
+                'htdocs/ckeditor/_source/skins/kama/*.*',
+                'htdocs/ckeditor/_source/skins/kama/images/*.*',
+                'htdocs/ckeditor/_source/core/*.*',
+                'htdocs/ckeditor/_source/core/dom/*.*',
+                'htdocs/ckeditor/_source/core/htmlparser/*.*',
+                'htdocs/ckeditor/adapters/*.*',
+                'htdocs/ckeditor/_samples/*.*',
+                'htdocs/ckeditor/_samples/asp/*.*',
+                'htdocs/ckeditor/_samples/php/*.*',
+                'htdocs/ckeditor/_samples/api_dialog/*.*',
+                'htdocs/ckeditor/_samples/assets/*.*',
+                'htdocs/ckeditor/_samples/adobeair/*.*',
+                'htdocs/ckeditor/images/*.*',
+        ],
     },
     entry_points = {
         'trac.plugins': [